image: maven:lates

stages:
  - build
  - test
  - deploy
  
build:
  stage: build
  tags:
   - quantr-assembler
  script:
    - mvn $MAVEN_CLI_OPTS -DskipTests compile

test-ia32:
  stage: test
  tags:
   - quantr-assembler
  rules:
   - if: '$CI_COMMIT_MESSAGE =~ /test-ia32/'
  script:
   - mvn $MAVEN_CLI_OPTS -Dtest=hk.quantr.assembler.ia32.FullTest test -DCI_JOB_ID=$CI_JOB_ID -DGITLAB_USER_ID="$GITLAB_USER_ID" -DGITLAB_USER_NAME="$GITLAB_USER_NAME" -DGITLAB_USER_EMAIL=$GITLAB_USER_EMAIL -DGITLAB_USER_LOGIN="$GITLAB_USER_LOGIN"

test-clear-gas:
  stage: test
  tags:
   - quantr-assembler
  rules:
   - if: '$CI_COMMIT_MESSAGE =~ /clear-gas/'
  script:
   - mvn $MAVEN_CLI_OPTS -Dtest=hk.quantr.assembler.riscv.ClearGas test -DCI_JOB_ID=$CI_JOB_ID -DGITLAB_USER_ID="$GITLAB_USER_ID" -DGITLAB_USER_NAME="$GITLAB_USER_NAME" -DGITLAB_USER_EMAIL=$GITLAB_USER_EMAIL -DGITLAB_USER_LOGIN="$GITLAB_USER_LOGIN"

test-riscv:
  stage: test
  tags:
   - quantr-assembler
  rules:
   - if: '$CI_COMMIT_MESSAGE =~ /test-riscv/'
  script:
   - mvn $MAVEN_CLI_OPTS -Dtest=hk.quantr.assembler.riscv.FullTest test -DCI_JOB_ID=$CI_JOB_ID -DGITLAB_USER_ID="$GITLAB_USER_ID" -DGITLAB_USER_NAME="$GITLAB_USER_NAME" -DGITLAB_USER_EMAIL=$GITLAB_USER_EMAIL -DGITLAB_USER_LOGIN="$GITLAB_USER_LOGIN"
   - mvn $MAVEN_CLI_OPTS -Dtest=hk.quantr.assembler.riscv.FullTestDisasm test -DCI_JOB_ID=$CI_JOB_ID -DGITLAB_USER_ID="$GITLAB_USER_ID" -DGITLAB_USER_NAME="$GITLAB_USER_NAME" -DGITLAB_USER_EMAIL=$GITLAB_USER_EMAIL -DGITLAB_USER_LOGIN="$GITLAB_USER_LOGIN"

deploy:
  stage: deploy
  tags:
   - quantr-assembler
  environment:
   name: test
   url: https://www.quantr.hk/asmweb
  script:
    - mvn $MAVEN_CLI_OPTS -DskipTests package
    
deploy jar:
  stage: deploy
  tags:
   - quantr-assembler
  script:
    - mvn $MAVEN_CLI_OPTS -DskipTests package
    - cp target/assembler*.jar /home/gitlab-runner/assembler/assembler.jar
    - mvn -DskipTests install deploy
